import fs from "fs";
import path from "path";

const CURR_DIR = process.cwd();

const createDirectoryContents = (templatePath, newProjectPath) => {
  const filesToCreate = fs.readdirSync(__dirname + templatePath);

  filesToCreate.forEach((file) => {
    const origFilePath = `${templatePath}/${file}`;

    const stats = fs.statSync(origFilePath);

    if (stats.isFile()) {
      const contents = fs.readFileSync(origFilePath, "utf8");
      const writePath = `${CURR_DIR}/${newProjectPath}/${file}`;
      fs.writeFileSync(writePath, contents, "utf8");
    } else if (stats.isDirectory()) {
      fs.mkdirSync(`${CURR_DIR}/${newProjectPath}/${file}`);
      createDirectoryContents(
        `${templatePath}/${file}`,
        `${newProjectPath}/${file}`,
      );
    }
  });
};

export const handleDirectoryContent = (framework, projectName) => {
  const commonFiles = `../templates/front-end/common`;
  const frameworkFiles = `../templates/front-end/${framework}`;

  createDirectoryContents(commonFiles, projectName);
  createDirectoryContents(frameworkFiles, projectName);
};
